#include "crc8_maxim.hpp"

Crc8Maxim::Crc8Maxim()
  : m_crc(0)
{
}

void Crc8Maxim::update (uint8_t data)
{
    const uint8_t i = (data ^ m_crc);
    m_crc = L[i&0x0F]^H[i>>4];
}

void Crc8Maxim::update (const uint8_t *data, const uint16_t size)
{
    uint16_t i;
    for (i = 0; i < size; ++i)
    {
	update(*(data++));
    }
}

const uint8_t Crc8Maxim::L[16]=
{
    0x00,0x5e,0xbc,0xe2,
    0x61,0x3f,0xdd,0x83,
    0xc2,0x9c,0x7e,0x20,
    0xa3,0xfd,0x1f,0x41
};
const uint8_t Crc8Maxim::H[16]=
{
    0x00,0x9d,0x23,0xbe,
    0x46,0xdb,0x65,0xf8,
    0x8c,0x11,0xaf,0x32,
    0xca,0x57,0xe9,0x74
};
