#ifndef __DIVA_SERIAL_PORT_H__
#define __DIVA_SERIAL_PORT_H__

#include <unistd.h> // ssize_t

class OpenSerialPortException
{
public:
    OpenSerialPortException(const char * _msg)
    {
    }
};

class SerialPortException
{
public:
    SerialPortException(const char * _msg)
    {
    }
};


class SerialPort
{
private:
    int m_fd;

public:
    SerialPort();
    ~SerialPort();

public:
    bool open(const char * _serialPortName);
    void close();
    bool isOpen() const;
    ssize_t read(char * _buffer, const size_t _size) const;
    ssize_t write(const char * _buffer, const size_t _size) const;

public:
    void WaitUntilTransmitterEmpty();
    void setBaudrate(const int _baudrate);
    void setFormat(const int _databits, const char _parity, const int _stopbits);
    void setHardwareHandshake(const bool _rtscts, const bool _dsrdtr);
    void makeRaw();
    void sendBreak(const int _duration_us);

//private:
    int  handle() const;
private:
    void setCustomBaudrate(const unsigned int _newBaudrate);
};
#endif
